Centos7下Nginx編譯安裝與腳本安裝的記錄

一、安裝工具及依賴

yum install -y wget make cmake gcc gcc-c++ \

yum install -y pcre pcre-devel lib zlib-devel  && \

openssl openssl-devel

二、下載及解壓nginx

wget http://nginx.org/download/nginx-1.12.2.tar.gz && \

tar -xzvf  nginx-1.12.2.tar.gz && rm -f nginx-1.12.2.tar.gz && cd nginx-1.12.2
[root@localhost nginx-1.12.2]# pwd
/usr/local/nginx-1.12.2

三、編譯安裝

./configure --prefix=/usr/local/nginx --with-http_ssl_module --with-http_realip_module --http-client-body-temp-path=/usr/local/var/tmp/nginx/client

--http-proxy-temp-path=/usr/local/var/tmp/nginx/proxy 
--http-fastcgi-temp-path=/usr/local/var/tmp/nginx/fcgi 
--http-scgi-temp-path=/usr/local/var/tmp/nginx/scgi 
--http-uwsgi-temp-path=/usr/local/var/tmp/nginx/uwsgi 
--with-http_geoip_module 
--with-http_stub_status_module

/usr/local/var/tmp/nginx/proxy
--http-fastcgi-temp-path=/usr/local/var/tmp/nginx/fcgi
--http-scgi-temp-path=/usr/local/var/tmp/nginx/scgi
--http-uwsgi-temp-path=/usr/local/var/tmp/nginx/uwsgi
--with-http_geoip_module
--with-http_stub_status_module
 

make && make install

 

四.檢查安裝

啓動Nginx,啓動完之後檢查nginx是否已經正常啓動

[root@localhost nginx-1.12.2]# /usr/local/nginx/sbin/nginx
[root@localhost nginx-1.12.2]# ps -ef |grep nginx
root      12563      1  0 14:44 ?        00:00:00 nginx: master process /usr/local/nginx/sbin/nginx
nobody    12564  12563  0 14:44 ?        00:00:00 nginx: worker process

root      12568   3627  0 14:45 pts/1    00:00:00 grep --color=auto nginx

五、nginx常用命令

/usr/local/nginx/sbin/nginx -s start 啓動nginx
/usr/local/nginx/sbin/nginx -s stop 關閉nginx
/usr/local/nginx/sbin/nginx -s reload 重啓nginx

六、配置防火牆

[root@localhost nginx-1.12.2]# firewall-cmd --zone=public --add-port=80/tcp --permanent
success
[root@localhost nginx-1.12.2]# firewall-cmd --reload
success

七、測試nginx訪問

通過瀏覽器訪問nginx歡迎頁,在地址欄輸入:http://192.168.220.16/,如下圖所示

Centos7下Nginx編譯安裝與腳本安裝的記錄

八、配置nginx

nginx最重要的配置文件nginx.conf

[root@localhost nginx-1.12.2]# vi /usr/local/nginx/conf/nginx.conf

#user nobody;

#開啓進程數 <=cpu數
worker_processes 1;

#錯誤日誌保存位置
#error_log logs/error.log;
#error_log logs/error.log notice;
#error_log logs/error.log info;

#進程號保存文件
#pid logs/nginx.pid;

#每個進程最大連接數(最大連接=連接數x進程數)每個worker允許同時產生多少個鏈接,默認1024
events {
worker_connections 1024;
}

http {
#文件擴展名與文件類型映射表
include mime.types;
#默認文件類型
default_type application/octet-stream;

#日誌文件輸出格式 這個位置相於全局設置
#log_format  main  '$remote_addr - $remote_user [$time_local] "$request" '
#                  '$status $body_bytes_sent "$http_referer" '
#                  '"$http_user_agent" "$http_x_forwarded_for"';

#請求日誌保存位置
#access_log  logs/access.log  main;

#打開發送文件
sendfile        on;
#tcp_nopush     on;

#keepalive_timeout  0;
#連接超時時間
keepalive_timeout  65;

#打開gzip壓縮
#gzip  on;

server {
    #監聽端口
    listen       80;
    #監聽域名
    server_name  localhost;

    #charset koi8-r;

    #nginx訪問日誌放在logs/host.access.log下,並且使用main格式(還可以自定義格式)
    #access_log  logs/host.access.log  main;

    #如果沒有location更明確的匹配訪問路徑的話,訪問請求都會被該location處理
    location / {
        #root指定nginx的根目錄爲/usr/local/nginx/html
        root   html;
         #默認訪問文件,歡迎頁先去html目錄下找index.html,如果找不到再去找index.htm
        index  index.html index.htm;
    }

    #error_page  404              /404.html;

    # redirect server error pages to the static page /50x.html
    #
    #錯誤頁面及其返回地址,錯誤碼爲500、502、503、504都會返回50.html錯誤頁面。
    error_page   500 502 503 504  /50x.html;
    location = /50x.html {
        root   html;
    }

    # proxy the PHP scripts to Apache listening on 127.0.0.1:80
    #
    #location ~ \.php$ {
    #    proxy_pass   http://127.0.0.1;
    #}

    # pass the PHP scripts to FastCGI server listening on 127.0.0.1:9000
    #
    #location ~ \.php$ {
    #    root           html;
    #    fastcgi_pass   127.0.0.1:9000;
    #    fastcgi_index  index.php;
    #    fastcgi_param  SCRIPT_FILENAME  /scripts$fastcgi_script_name;
    #    include        fastcgi_params;
    #}

    # deny access to .htaccess files, if Apache's document root
    # concurs with nginx's one
    #
    #location ~ /\.ht {
    #    deny  all;
    #}
}

# another virtual host using mix of IP-, name-, and port-based configuration
#
#server {
#    listen       8000;
#    listen       somename:8080;
#    server_name  somename  alias  another.alias;

#    location / {
#        root   html;
#        index  index.html index.htm;
#    }
#}

# HTTPS server
#
#server {
#    listen       443 ssl;
#    server_name  localhost;

#    ssl_certificate      cert.pem;
#    ssl_certificate_key  cert.key;

#    ssl_session_cache    shared:SSL:1m;
#    ssl_session_timeout  5m;

#    ssl_ciphers  HIGH:!aNULL:!MD5;
#    ssl_prefer_server_ciphers  on;

#    location / {
#        root   html;
#        index  index.html index.htm;
#    }
#}

}
配置文件裏可以添加多個server,server監聽的端口不同,可以根據需要讓nginx代理多個端口,每個端口指定去做某些事情。

9、腳本安裝nginx

#!/usr/bin/env bash
echo -e '\e[31mInstallation tools and dependencies\e[0m'
yum install -y wget make cmake gcc gcc-c++
yum install -y pcre-devel lib zlib-devel openssl openssl-devel
if [ $? -eq 0 ];then
echo -e '\e[32mSuccessful!\e[0m'
else
echo -e '\e[31mFailed\e[0m'
exit 0
fi
echo -e '\e[31mInstallation nginx\e[0m'
wget http://nginx.org/download/nginx-1.12.2.tar.gz \
tar -xzvf nginx-1.12.2.tar.gz && rm -f nginx-1.12.2.tar.gz && cd nginx-1.12.2 \
./configure --prefix=/usr/local/nginx \
make && make install
if [ $? -eq 0 ];then
echo -e '\e[32mSuccessful!\e[0m'
else
echo -e '\e[31mFailed\e[0m'
exit 0
fi
echo -e '\e[31mStart nginx\e[0m'
/usr/local/nginx/sbin/nginx
echo -e '\e[32mSuccessful!\e[0m'
親測成功!主要防火牆開放80端口!

9、創建nginx啓動命令腳本
vi /etc/init.d/nginx

#! /bin/bash

chkconfig: - 85 15

PATH=/usr/local/nginx
DESC="nginx daemon"
NAME=nginx
DAEMON=$PATH/sbin/$NAME
CONFIGFILE=$PATH/conf/$NAME.conf
PIDFILE=$PATH/logs/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
set -e
[ -x "$DAEMON" ] || exit 0
do_start() {
$DAEMON -c $CONFIGFILE || echo -n "nginx already running"
}
do_stop() {
$DAEMON -s stop || echo -n "nginx not running"
}
do_reload() {
$DAEMON -s reload || echo -n "nginx can't reload"
}
case "$1" in
start)
echo -n "Starting $DESC: $NAME"
do_start
echo "."
;;
stop)
echo -n "Stopping $DESC: $NAME"
do_stop
echo "."
;;
reload|graceful)
echo -n "Reloading $DESC configuration..."
do_reload
echo "."
;;
restart)
echo -n "Restarting $DESC: $NAME"
do_stop
do_start
echo "."
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|reload|restart}" >&2
exit 3
;;
esac
exit 0
chmod a+x /etc/init.d/nginx #設置執行權限
chkconfig --add nginx  #註冊成服務
chkconfig nginx on  #設置開機啓動
#啓動nginx服務
service nginx start
#停止nginx服務
service nginx stop
#重啓nginx服務
service nginx restart
#重新讀取nginx配置(這個最常用, 不用停止nginx服務就能使修改的配置生效)
service nginx reload

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章